#include "csapp.h"

/* Demonstrates using mprotect() to pick your own permissions,
   then using signal() to change your mind. */

static char *s;
static size_t sz = 1<<14;

void recover(int sig)
{
  printf("ouch...\n");
  mprotect(s, sz, PROT_READ | PROT_WRITE);
}

int main()
{
  s = Mmap(0, sz, 
           PROT_READ | PROT_WRITE | PROT_EXEC, 
           MAP_PRIVATE | MAP_ANON, 
           -1, 0);

  printf("Trying %p\n", s);
  s[0] = 0xC3;
  ((void (*)())s)();
  printf("ok\n");

  mprotect(s, sz, PROT_READ | PROT_EXEC);

  ((void (*)())s)();
  printf("still ok\n");

  Signal(SIGSEGV, recover); /* Linux, most BSDs */
  Signal(SIGBUS, recover);  /* Mac OS X, some other BSDs */

  s[0] = 0x0;
  printf("ok, after all\n");

  return 0;
}
